/* basics.c

Functions to perform basic mathematical operations

    Copyright (C) 1999, 2000 Conrado Badenas <Conrado.Badenas@uv.es>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "basics.h"

#include <math.h>
#include <stdlib.h>

#include "number.h"

Number hyptns(Number x,Number y)
{
	Number absx,absy,ratio;
	
	absx=fabs(x);absy=fabs(y);
	if (absx>absy) {ratio=absy/absx;return absx*sqrt(1.+ratio*ratio);}
	if (absx)      {ratio=absx/absy;return absy*sqrt(1.+ratio*ratio);}
	return 0.;
}

Number powint(Number base,int exponent)
{
	Number result;
	int i,absexp;

	result=1.;
	absexp=abs(exponent);
	for (i=0;i<absexp;i++) result*=base;
	if (exponent<0) result=1./result;
	return result;
}

Number sgn(Number x)
{
	return (x>0. ? 1. : (x<0. ? -1. : 0.));
}
