/* memo.c

Functions to allocate (reallocate) and free memory for various objects

    Copyright (C) 1999, 2000 Conrado Badenas <Conrado.Badenas@uv.es>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "memo.h"

#include <stdio.h>
#include <stdlib.h>

#include "macros.h"
#include "number.h"

void *mycalloc(size_t numelems,size_t sizeofelem)
{
	void *ptr;
	
	ptr=calloc(numelems,sizeofelem);
	if (ptr==NULL) FATAL3("mycalloc(): Could not allocate "
		"%u elems of %u bytes\n",numelems,sizeofelem)
	return ptr;
}

void *myrealloc(void *oldptr,size_t numelems,size_t sizeofelem)
{
	void *ptr;
	
	ptr=realloc(oldptr,numelems*sizeofelem);
	if (ptr==NULL) FATAL3("myrealloc(): Could not reallocate "
		"%u elems of %u bytes\n",numelems,sizeofelem)
	return ptr;
}

Number *vector(size_t num)
{
	return (Number*)(mycalloc(num,sizeof(Number)));
}

void f_vector(Number *v,size_t num)
{
	free((void*)v);
}
